# --------------
# simple_ds.py - Simple Descriptive Statistics
# --------------


#
# mean() - compute the sample mean.
#     Parameters:
#         N a list of numbers
#
def mean( N ):
    # running total
    Total = 0
    # count of the number of items
    Count = len(N)
    # for each item in the list
    for Num in N:
        # increment the total
        Total = Total + Num
    # compute the sample average
    average = float(Total)/Count if Count > 0 else 0
    return(average)



#
# std_dev() - compute the sample standard deviation.
#     Parameters:
#         N a list of numbers
#
def std_dev( N ):
    Count = len(N)
    # Compute the average
    average = mean(N)
    if Count > 1:
        # Compute the std dev.
        Total = 0
        for Num in N:
            Total = Total + (float(Num) - average)**2
        std_dev = ((float(1)/(Count-1))*Total)**(float(1)/2)
    else:
        std_dev = 0
    return(std_dev)



# default main() for command-line execution.
def main():
    Numbers = [123, 87, 96, 24, 104, 16, 85, 55, 62, 109]
    # display output
    print 'Numbers: {}'.format(Numbers)
    the_avg = mean(Numbers)
    print 'Average: {:.3f}'.format(the_avg)
    the_std_dev = std_dev(Numbers)
    print 'Standard deviation: {:.3f}'.format(the_std_dev)



# This line causes main() to be executed if this file (module)
# is executed without an import (i.e., from the command line).
# If the module is imported, the condition will fail.
if __name__ == "__main__": main()
